/*
 * Use the jQuery API (library) with built in objects
 * See http://learn.jquery.com/
 */
// '$' is the jQuery object (represents the API)
// Function run when DOM is finished loading (= document.ready() )
$(function() {
    // Connecting eventhandlers to elements, jQuery style
    $("#create").on("click", list.create); // Not no parenteses on function!
    $("#remove").on("click", list.destroy);
});

var list = {
    data: [
        "New York",
        "LA",
        "Seattle",
        "Pittsburg",
        "Wichita",
        "Boise"
    ],

    create: function() {

        var ul = $("<ul/>");
        // Internal iteration, call anonymous function for each element
        $.each(list.data, function(index, data) {
            var li = $("<li>" + data + "</li>");
            ul.append(li);
        });
        // Variations: before() and after();
        $("#container").append(ul);
    },
    destroy: function() {
        $("#container").empty();
    }
};
