package mvc.control;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import mvc.model.Model;
import mvc.model.Person;

/**
 * The control part (handling all POSTs, or other if needed)
 * @author hajo
 */
@WebServlet(name = "FrontController", urlPatterns = {"/fc"})
public class FrontController extends HttpServlet {

    private static final Logger LOG = Logger.getAnonymousLogger();
    private static final Level I = Level.INFO;

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {

        String action = req.getParameter("action");
        LOG.log(I, "Action {0}", action);

        switch (action) {
            case "add":
                int id = Integer.parseInt(req.getParameter("id"));
                String name = req.getParameter("name");
                add(id, name);
                break;
            case "delete":
                id = Integer.parseInt(req.getParameter("id"));
                delete(id);
                break;
            default: ;
        }
         // PRG pattern
        resp.sendRedirect("/mvc/list.jsp");
    }

    // Complex operations could be delegated to helper classes
    // Also specific operations could be handled by other servlets
    // (this is NOT complex, just a demo)
    private void add(int id, String name) throws IOException {
        Model.INSTANCE.getPersons().add(new Person(id, name));
    }

    private void delete(int id)
            throws IOException {
        Person p = Model.INSTANCE.getById(id);
        if (p != null) {
            Model.INSTANCE.getPersons().remove(p);
        }
    }

}
