package mvc.control;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;

/**
 * Filter is a general utility to process request and responses
 * (timing, compression, inspecting/adding headers, etc.)
 * May be chained to create a processing pipeline.
 * 
 * @author hajo
 */
@WebFilter(filterName = "SampleFIlter", urlPatterns = {"/*"})
public class SampleFIlter implements Filter {

    private static final Logger LOG = Logger.getAnonymousLogger();

    @Override
    public void doFilter(ServletRequest request, ServletResponse response,
            FilterChain chain)
            throws IOException, ServletException {

        // Must do if need request data
        //HttpServletRequest req = (HttpServletRequest) request;
        LOG.log(Level.INFO, "Filter hit: Before");
        chain.doFilter(request, response);
        LOG.log(Level.INFO, "Filter hit: After");
    }

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
    }

    @Override
    public void destroy() {
    }
}
