package edu.chl.hajo.shop.core;

import java.io.Serializable;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.Id;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;


/**
 * A Customer
 *
 * @author hajo
 */
@NoArgsConstructor
@EqualsAndHashCode(of = {"email"})
@Entity
public class Customer implements Serializable {
    @Id
    @Getter
    private String email;  
    @Getter
    @Setter
    private String firstName;
    @Setter
    @Getter
    private String lastName;
    @Getter
    @Setter
    @Embedded
    private Address address;
    @Setter
    @Getter
    private transient Cart cart;

    public Customer(String email, String firstName, String lastName, Address address, Cart cart) {
        this.cart = new Cart();
        this.email = email;
        this.firstName = firstName;
        this.lastName = lastName;
        this.address = address;
        this.cart = cart;
    }
}
