package edu.chl.hajo.shop.dao;

import edu.chl.hajo.shop.core.Customer;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;


/**
 * All customers.
 * Responsible for putting new Customers objects
 * into the model
 *
 * @author hajo
 */

/*
   Stateless = This is a special transactional aware class.
   A lot is handled automatically by container (server).
   This is known as Container Managed Persistence
   See also persistence.xml, type is JTA.
 
*/
@Stateless
public class CustomerRegistry extends AbstractDAO<Customer, String> {

    // Injected (possible because of running in full size application server
    // also possible in other servers but then have to add CDI)
    @PersistenceContext
    private EntityManager em;

    public CustomerRegistry() {
        super(Customer.class);
    }
    
    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

  
}
