package query.dao;

import com.querydsl.jpa.impl.JPAQueryFactory;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import query.model.Customer;
import query.model.QCustomer;
import query.model.QPurchaseOrder;

/**
 * NOTE: Many named queries for single attribute selection, see Manufacturer
 * class
 *
 * @author hajo
 */
@Stateless
public class CustomerDAO extends AbstractDAO<Customer, Integer> {

    @PersistenceContext
    private EntityManager em;

    public CustomerDAO() {
        super(Customer.class);
    }

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public List<Customer> VIPCustomersSQL() {
        String sql = "select CUSTOMER.* from PURCHASE_ORDER inner join CUSTOMER on "
                + "PURCHASE_ORDER.CUSTOMER_ID = CUSTOMER.CUSTOMER_ID where PURCHASE_ORDER.QUANTITY > 100";
        return em
                .createNativeQuery(sql, Customer.class)
                .getResultList();
    }

    public List<Customer> VIPCustomers() {
        QPurchaseOrder po = QPurchaseOrder.purchaseOrder;
        QCustomer cu = QCustomer.customer;
        JPAQueryFactory cf = new JPAQueryFactory(em);
        return cf.select(cu).from(po).innerJoin(po.customerId, cu).where(po.quantity.gt(100)).fetch();
    }
}
