package query.dao;

import com.querydsl.jpa.impl.JPAQuery;
import com.querydsl.jpa.impl.JPAQueryFactory;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import query.model.Manufacturer;
import query.model.QManufacturer;

/**
 * NOTE: Many named queries for single attribute selection, see Manufacturer
 * class
 *
 * @author hajo
 */
@Stateless
public class ManufacturerDAO extends AbstractDAO<Manufacturer, Integer> {

    @PersistenceContext
    private EntityManager em;

 
    public ManufacturerDAO() {
        super(Manufacturer.class);
    }

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }
    
     // Avoid
    public List<Manufacturer> getByStatesSQL(String[] states) {
        // Just a sketch, you need to cut and paste in the sql string
       String sql = "select * from Manufacturer where state = 'CA'";
       return em
               .createNativeQuery(sql, Manufacturer.class)
               .getResultList();
    }
    

    // QManufacturer generated by QueryDsl
    public List<Manufacturer> getByStates(String[] states) {
        JPAQueryFactory cf = new JPAQueryFactory(em);
        QManufacturer m = QManufacturer.manufacturer;
        List<Manufacturer> result = new ArrayList<>();
        for( String s : states ){
          result.addAll(cf.selectFrom(m).where(m.state.eq(s)).fetch());
        }
        return result;
    }
       
}