var express = require('express');
var personList = require('../models/personlist.js');

var router = express.Router();

// List notes for current user
router.get('/', function(req, res, next) {
    personList.getPersons(function(err, rows, fields) {
        //console.log(JSON.stringify(rows));
        console.log(rows);
        res.render('list', {personList: rows});
    })
});

router.get('/add', function(req, res, next) {
    res.render('add', {text: 'Add a Person'});
});

router.post('/add', function(req, res, next) {
    console.log("Post add" + req.body.name);
    personList.add(req.body.name);
    res.redirect("/list");
});

router.get('/delete', function(req, res, next) {
    console.log("Get delete " + req.query.id);
    personList.getById(parseInt(req.query.id), function(err, row, fields) {
        console.log("Row" + JSON.stringify(row[0]));
        res.render('delete', {
            text: 'Delete Person',
            person: row[0]
        });
    })
});

router.post('/delete', function(req, res, next) {
    console.log("Post delete " + req.body.id);
    personList.delete(parseInt(req.body.id));
    res.redirect("/list");
});

module.exports = router;
