package rest.model;

import java.util.concurrent.atomic.AtomicLong;

/**
 * Specific model class
 *
 * @author hajo
 */
public class Person {

    private final Long id;
    private final String name;
    private static final AtomicLong counter = new AtomicLong(100);

    public Person(Long id, String name) {
        if (id != null) {
            this.id = id;
        } else {
            this.id = counter.getAndIncrement();
        }
        this.name = name;
    }

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

}
