/*

  A collection of Persons

*/
// Define dependencies
define([
    'underscore', 'backbone', 'backboneLocalstorage', 'models/person'
], function(_, Backbone, Store, Person) { // Inject dependencies (in order)
    'use strict';
    /*
    	All CRUD methods are defined by Backbone (i.e. there are hidden functions)
    	- PersonList.add()
    	- PersonList.remove(id)
    	- PersonList.add(...)
    	- PersonList.length();
    	- etc. see Backbone docs.

    */
    var PersonList = Backbone.Collection.extend({

        // Should specify which model "class" the collection handles
        model: Person,

        // Use browsers localstore instead of AJAX backend
        // See: Chrome: Dev tools > Application > Local Storage > ...
        // MUST: Have this else Backbone automatically will do AJAX requests
        localStorage: new Store('persons-backbone'),

        // Specify which id to use (not the autogenerated by Backbone = cid)
        modelId: function(attributes) {
            // Attributes are part of Person.
            return attributes.id;
        },

        // Lika a constructor
        initialize: function() {
            // Will call Person.initialize
            this.create(1, "pelle");
            this.create(2, "fia");
            //this.create(3, "olle");
            this.add(new Person(2, "olle"));
        }
    });

    return PersonList;
});
