package jeecomp.viewmodel;

import jeecomp.core.Person;
import jeecomp.core.PersonRegistry;
import java.io.Serializable;
import java.util.Collection;
import javax.faces.view.ViewScoped;  // NOTE : NOT beans.ViewScoped; 
import javax.inject.Inject;
import javax.inject.Named;
import lombok.Getter;


/**
 * Backing bean for personList.xhtml, CDI bean
 *
 * Using View scoped because of AJAX calls (i.e. same page, else navigation data
 * lost)
 *
 * @author hajo
 */
@Named("personlist")
@ViewScoped  
public class PersonListBB implements Serializable {

    private PersonRegistry reg;
    @Getter
    private int currentPage;
    private int pageSize = 10; // Only read this
   
    protected PersonListBB() {
        // Must have for CDI
    }

    @Inject
    public void setPersonRegistry(PersonRegistry reg) {
        this.reg = reg;
    }

    public Collection<Person> getList() {
        return reg.findRange(pageSize * currentPage, pageSize);
    }

    public void next() {
        if (reg.size() / pageSize > currentPage) {
            currentPage++;
        }
    }

    public void prev() {
        if (currentPage > 0) {
            currentPage--;
        }
    }    
}
