package edu.chl.hajo.cycle;

import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.event.ComponentSystemEvent;
import javax.inject.Named;
import static edu.chl.hajo.cycle.LogUtil.*;

/**
 * A simple managed bean. Data set by JSF cycle
 *
 * @author hajo
 */
@Named("MyBean")
@SessionScoped //@RequestScoped 
public class MyBean implements Serializable {

    private String data = "default value";

    @PostConstruct
    public void post() {
        isAlive(this, GREEN);
    }

    @PreDestroy
    public void pre() {
        info(this + " to be destroyed", GREEN);
    }

    public String getData() {
        info("*** Getting data from MyBean. Data is: " + data, RED);
        return data;
    }

    public void setData(String data) {
        LogUtil.info("*** Setting data in MyBean to " + data, RED);
        this.data = data;
    }

    public void render(ComponentSystemEvent evt) {
        info("*** Call prerender (on MyBean) " + evt.toString());
    }
}
