package primepush;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.faces.application.FacesMessage;
import org.primefaces.push.RemoteEndpoint;
import org.primefaces.push.annotation.OnClose;
import org.primefaces.push.annotation.OnMessage;
import org.primefaces.push.annotation.OnOpen;
import org.primefaces.push.annotation.PushEndpoint;
import org.primefaces.push.impl.JSONEncoder;

@PushEndpoint("/notify")
//@PushEndpoint("/somepath/{room}/{user}")   Path params possible
public class NotifyResource {

    private static final Logger LOG = Logger.getLogger(NotifyResource.class.getSimpleName());

    public NotifyResource() {
        LOG.log(Level.INFO, "*** Notify Resource Alive");
    }

    // Will be invoked as a result of an EventBus.publish
    @OnMessage(encoders = {JSONEncoder.class})
    public FacesMessage onMessage(FacesMessage message) {
        LOG.log(Level.INFO, "*** onMessage summary: {0} detail: {1}", new Object[]{message.getSummary(), message.getDetail()});
        return message;
    }

    // ---- Other methods not used --------------
    /*@OnOpen
    public void onOpen() {
    }*/

    @OnOpen
    public void onOpen(RemoteEndpoint r) { // Remote Endpoint is the browser
        LOG.log(Level.INFO, "*** onOpen {0}", r.address());
    }

    /*@OnOpen
    public void onOpen(RemoteEndpoint r, EventBus e) {
    }*/

    @OnClose
    public void onClose() {
    }

    @OnClose
    public void onClose(RemoteEndpoint r) {
    }

    /*@OnClose
    public void onClose(RemoteEndpoint r, EventBus e) {
    }*/
}
