package edu.hajo.chl.ri;

import edu.hajo.chl.ri.cdi.HelloCDI;
import edu.hajo.chl.ri.ejb.HelloEJB;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.json.Json;
import javax.json.JsonObject;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Response;

/**
 * REST Web Service
 *
 * @author hajo
 */
@Path("hello")
@RequestScoped    // *** MUST have this for CDI to work, ...!!! ***
public class HelloResource {

    private HelloEJB hejb;
    private HelloCDI hcdi;

    @GET
    @Produces("application/json")
    public Response getJson(@QueryParam(value = "name") String name) {
        String ejb = hejb.getHello(name);
        String cdi = hcdi.getHello(name);
        JsonObject obj = Json.createObjectBuilder()
                .add("ejb-message", ejb)
                .add("cdi-message", cdi)
                .build();
        return Response.ok(obj).build();
    }

    @EJB
    public void setHejb(HelloEJB hejb) {
        this.hejb = hejb;
    }

    @Inject
    public void setHcdi(HelloCDI hcdi) {
        this.hcdi = hcdi;
    }
    
}
